
CSPIFF                  ST Programmer's Manual                  CSPIFF

NAME
     cspiff - Improve appearance of C source files

SYNOPSIS
     cspiff [-i file -l int -r int -o file -t int]

DESCRIPTION
     cspiff reads a C source file, and writes a file with the same
     information in a more columnar format. Defaults are to read stdin,
     and write stdout.

-i   The -i option may be used to specify an input file name. There
     may or may not be one or more spaces between the -i and the name
     of the file.

-l   The -l option may be used to set the column to which the left
     edge of trailing comments are aligned. Default is column 40.

-r   The -r option may be used to set the column to which the right
     edge of trailing comments are aligned. Default is column 78.

-o   The -o option may be used to specify an output file name. There
     may or may not be one or more spaces between the -o and the name
     of the file.

-t   The -t option may be used to set the indentation (tab) spacing.
     Each encountered indentation of a code line will be revised to a
     new indentation equal to the number of spaces specified by the
     -t option. Default is 2 spaces.

     If there is an argument on the command line, and no option flags,
     the argument is assumed to be an input file name.

BUGS
     None known.

AUTHOR
     George R. Woodside           PPN 76537,1342
     5219 San Feliciano Drive
     Woodland Hills, Ca. 91364

Printed 01/22/87                                                1
