(*$T-,$S-*)
IMPLEMENTATION MODULE FileSelectorDialog;

FROM SYSTEM IMPORT
       CODE,ADR,ADDRESS;
FROM GEMDOS IMPORT
       SFirst,SNext,GetDTA;
FROM BIOS IMPORT
       DriveSet,DriveMap;
FROM GEMAESbase IMPORT
       Object,TEdInfo,FormStart,FormGrow,FormShrink,FormFinish;
FROM AESObjects IMPORT
       ObjectDraw,ObjectChange,ObjectOffset;
FROM AESForms IMPORT
       FormDo,FormCenter,FormDialogue;
FROM AESGraphics IMPORT
       GrafSlideBox,GrafMouseKeyboardState;
FROM UCSDStuff IMPORT
       MoveLeft,MoveRight,Scan;

(*----------- Resource File Constants -----------------*)

CONST
  FILESLCT = 0 ;
    DRIVEA = 3 ;
    DRIVEB = 4 ;
    DRIVEC = 5 ;
    DRIVED = 6 ;
    DRIVEE = 7 ;
    DRIVEF = 8 ;
    DRIVEG = 9 ;
    DRIVEH = 10 ;
   MENUBOX = 13 ;
   MCLOSER = 14 ;
   MVSLIDE = 15 ;
  SLIDEBOX = 16 ;
  MUPARROW = 17 ;
  MDNARROW = 18 ;
   MTOPBAR = 19 ;
  MTOPTEXT = 20 ;
     FILE1 = 21 ;
     FILE2 = 22 ;
     FILE3 = 23 ;
     FILE4 = 24 ;
     FILE5 = 25 ;
     FILE6 = 26 ;
     FILE7 = 27 ;
     FILE8 = 28 ;
     FILE9 = 29 ;
    FILE10 = 30 ;
  DIRECTRY = 32 ;
      EXT1 = 33 ;
      EXT2 = 34 ;
      EXT3 = 35 ;
      EXT4 = 36 ;
      EXT5 = 37 ;
      EXT6 = 38 ;
  FILENAME = 41 ;
  SELECTOK = 42 ;
  SELECTCA = 43 ;

(*--------------------*)

CONST Selected=0;
      Disabled=3;

TYPE Tree=POINTER TO ARRAY[0..200] OF Object;
     TedPtr = POINTER TO TEdInfo;

     FileID = RECORD
                    Name:ARRAY[0..14] OF CHAR;
              END;

     DirectoryList = ARRAY[0..143] OF FileID;

     DirEntry = RECORD
                      Reserved:ARRAY[0..20] OF CHAR;
                      FileAttr:CHAR;
                      TimeOfCreation:INTEGER;
                      DateOfCreation:INTEGER;
                      FileSize:LONGCARD;
                      Filename:ARRAY[0..13] OF CHAR;
                END;

VAR ob:Tree;
    x,y,w,h:INTEGER;

(*****************************************************)

MODULE Resource;

IMPORT CODE,ADDRESS,Object,TEdInfo,ob;
EXPORT RESOURCEDATA0,InitResourceTree;

(*
   Produced by ResourceMaker 0.00a
   Copyright (c) 1985, 1986 TDI Software, Inc.
   By Paul Curtis

   Resource file version: 00000H
*)

CONST
     (* object types that don't have to be relocated *)
     GBOX = 20;
     GPROGDEF = 24;
     GIBOX = 25;
     GBOXCHAR = 27;

     (* resource file object counts and indicies *)
     nrObjects = 44;  ixObjects = 534;
     nrTrees = 1;     ixTrees = 1590;
     nrTedInfos = 3;  ixTedInfos = 450;

VAR  i:CARDINAL;
     o:INTEGER;
     x:ADDRESS;
     TreeAddr:POINTER TO ARRAY[0..nrTrees-1] OF ADDRESS;
     TedInfoAddr:POINTER TO ARRAY[0..nrTedInfos-1] OF TEdInfo;
     ObjectAddr:POINTER TO ARRAY[0..nrObjects-1] OF Object;

(*........................................................*)

(*$P-*)
PROCEDURE RESOURCEDATA0;
BEGIN
    (* resource file data inserted into CODE stream *)
    CODE(00000H,00216H,001C2H,001C2H,001C2H,001C2H,00024H,001C2H);
    CODE(001C2H,00636H,0002CH,00001H,00003H,00000H,00000H,00000H);
    CODE(00000H,0063AH,04649H,04C45H,02053H,0454CH,04543H,0544FH);
    CODE(05220H,0424FH,05800H,0413AH,00042H,03A00H,0433AH,00044H);
    CODE(03A00H,0453AH,00046H,03A00H,0473AH,00048H,03A00H,04472H);
    CODE(06976H,0653AH,00020H,02A2EH,02A20H,00000H,02020H,05F5FH);
    CODE(05F5FH,05F5FH,05F5FH,02E5FH,05F5FH,00020H,0205FH,05F5FH);
    CODE(05F5FH,05F5FH,05F2EH,05F5FH,05F00H,02020H,05F5FH,05F5FH);
    CODE(05F5FH,05F5FH,02E5FH,05F5FH,00020H,0205FH,05F5FH,05F5FH);
    CODE(05F5FH,05F2EH,05F5FH,05F00H,02020H,05F5FH,05F5FH,05F5FH);
    CODE(05F5FH,02E5FH,05F5FH,00020H,0205FH,05F5FH,05F5FH,05F5FH);
    CODE(05F2EH,05F5FH,05F00H,02020H,05F5FH,05F5FH,05F5FH,05F5FH);
    CODE(02E5FH,05F5FH,00020H,0205FH,05F5FH,05F5FH,05F5FH,05F2EH);
    CODE(05F5FH,05F00H,02020H,05F5FH,05F5FH,05F5FH,05F5FH,02E5FH);
    CODE(05F5FH,00020H,0205FH,05F5FH,05F5FH,05F5FH,05F2EH,05F5FH);
    CODE(05F00H,04469H,07265H,06374H,06F72H,0793EH,0005FH,05F5FH);
    CODE(05F5FH,05F5FH,05F5FH,05F5FH,05F5FH,05F5FH,05F5FH,05F5FH);
    CODE(05F5FH,05F5FH,05F5FH,05F5FH,05F5FH,05F5FH,05F5FH,05F5FH);
    CODE(05F5FH,05F5FH,0005FH,05F5FH,05F5FH,05F5FH,05F5FH,05F5FH);
    CODE(05F5FH,05F5FH,05F5FH,05F5FH,05F5FH,05F5FH,05F5FH,05F5FH);
    CODE(05F5FH,05F5FH,05F5FH,05F5FH,05F5FH,05F5FH,00058H,05858H);
    CODE(05858H,05858H,05858H,05858H,05858H,05858H,05858H,05858H);
    CODE(05858H,05858H,05858H,05858H,05858H,05858H,05858H,05858H);
    CODE(05858H,05858H,0002EH,02A00H,02E2AH,0002EH,02A00H,02E2AH);
    CODE(0002EH,02A00H,02E2AH,00053H,0656CH,06563H,07469H,06F6EH);
    CODE(03E00H,05F5FH,05F5FH,05F5FH,05F5FH,05F5FH,05F00H,05F5FH);
    CODE(05F5FH,05F5FH,05F5FH,02E5FH,05F5FH,00046H,04646H,04646H);
    CODE(04646H,04646H,04646H,0004FH,04B00H,04341H,04E43H,0454CH);
    CODE(00000H,00000H,00055H,00000H,00000H,00000H,0005BH,00003H);
    CODE(00006H,00000H,01180H,00000H,000FFH,00006H,00001H,00000H);
    CODE(000FDH,00000H,00125H,00000H,0014DH,00003H,00006H,00000H);
    CODE(01180H,00000H,000FFH,00028H,00028H,00000H,00192H,00000H);
    CODE(0019EH,00000H,001ABH,00003H,00006H,00000H,01180H,00000H);
    CODE(000FFH,0000CH,0000DH,0FFFFH,00001H,0002BH,00014H,00000H);
    CODE(00010H,00002H,01100H,00000H,00000H,0002EH,00017H,00002H);
    CODE(0FFFFH,0FFFFH,0001CH,00000H,00000H,00000H,00024H,0000FH);
    CODE(00001H,00012H,00001H,00003H,0FFFFH,0FFFFH,00014H,00080H);
    CODE(00000H,000FFH,01100H,00003H,00002H,0002AH,00002H,00004H);
    CODE(0FFFFH,0FFFFH,0001AH,00015H,00000H,00000H,00036H,0000BH);
    CODE(00003H,00003H,00001H,00005H,0FFFFH,0FFFFH,0001AH,00015H);
    CODE(00000H,00000H,00039H,0000FH,00003H,00003H,00001H,00006H);
    CODE(0FFFFH,0FFFFH,0001AH,00015H,00000H,00000H,0003CH,00013H);
    CODE(00003H,00003H,00001H,00007H,0FFFFH,0FFFFH,0001AH,00015H);
    CODE(00000H,00000H,0003FH,00017H,00003H,00003H,00001H,00008H);
    CODE(0FFFFH,0FFFFH,0001AH,00015H,00000H,00000H,00042H,0001BH);
    CODE(00003H,00003H,00001H,00009H,0FFFFH,0FFFFH,0001AH,00015H);
    CODE(00000H,00000H,00045H,0001FH,00003H,00003H,00001H,0000AH);
    CODE(0FFFFH,0FFFFH,0001AH,00015H,00000H,00000H,00048H,00023H);
    CODE(00003H,00003H,00001H,0000BH,0FFFFH,0FFFFH,0001AH,00015H);
    CODE(00000H,00000H,0004BH,00027H,00003H,00003H,00001H,0000CH);
    CODE(0FFFFH,0FFFFH,00014H,00080H,00000H,000FFH,01100H,00003H);
    CODE(00005H,0002AH,00004H,0000DH,0FFFFH,0FFFFH,0001CH,00000H);
    CODE(00000H,00000H,0004EH,00003H,00003H,00006H,00001H,0001FH);
    CODE(0000EH,0001EH,00014H,00040H,00000H,000FFH,01100H,00003H);
    CODE(0000AH,00017H,0000CH,0000FH,0FFFFH,0FFFFH,0001BH,00040H);
    CODE(00000H,005FFH,01100H,00000H,00000H,00002H,00001H,00011H);
    CODE(00010H,00010H,00014H,00040H,00000H,000FFH,01111H,00015H);
    CODE(00002H,00002H,00009H,0000FH,0FFFFH,0FFFFH,00014H,00040H);
    CODE(00000H,000FFH,01100H,00000H,00000H,00002H,00001H,00012H);
    CODE(0FFFFH,0FFFFH,0001BH,00040H,00000H,001FFH,01100H,00015H);
    CODE(00001H,00002H,00001H,00013H,0FFFFH,0FFFFH,0001BH,00040H);
    CODE(00000H,002FFH,01100H,00015H,0000BH,00002H,00001H,00015H);
    CODE(00014H,00014H,00014H,00040H,00000H,000FFH,01121H,00002H);
    CODE(00000H,00015H,00001H,00013H,0FFFFH,0FFFFH,00015H,00040H);
    CODE(00000H,00000H,001C2H,00007H,00000H,00005H,00001H,00016H);
    CODE(0FFFFH,0FFFFH,0001CH,00051H,00000H,00000H,0005CH,00002H);
    CODE(00001H,00010H,00001H,00017H,0FFFFH,0FFFFH,0001CH,00051H);
    CODE(00000H,00000H,0006BH,00002H,00002H,00010H,00001H,00018H);
    CODE(0FFFFH,0FFFFH,0001CH,00051H,00000H,00000H,0007AH,00002H);
    CODE(00003H,00010H,00001H,00019H,0FFFFH,0FFFFH,0001CH,00051H);
    CODE(00000H,00000H,00089H,00002H,00004H,00010H,00001H,0001AH);
    CODE(0FFFFH,0FFFFH,0001CH,00051H,00000H,00000H,00098H,00002H);
    CODE(00005H,00010H,00001H,0001BH,0FFFFH,0FFFFH,0001CH,00051H);
    CODE(00000H,00000H,000A7H,00002H,00006H,00010H,00001H,0001CH);
    CODE(0FFFFH,0FFFFH,0001CH,00051H,00000H,00000H,000B6H,00002H);
    CODE(00007H,00010H,00001H,0001DH,0FFFFH,0FFFFH,0001CH,00051H);
    CODE(00000H,00000H,000C5H,00002H,00008H,00010H,00001H,0001EH);
    CODE(0FFFFH,0FFFFH,0001CH,00051H,00000H,00000H,000D4H,00002H);
    CODE(00009H,00010H,00001H,0000DH,0FFFFH,0FFFFH,0001CH,00051H);
    CODE(00000H,00000H,000E3H,00002H,0000AH,00010H,00001H,00020H);
    CODE(0FFFFH,0FFFFH,0001CH,00000H,00000H,00000H,000F2H,00003H);
    CODE(00005H,0000AH,00001H,00021H,0FFFFH,0FFFFH,0001DH,00008H);
    CODE(00000H,00000H,001DEH,00003H,00006H,00027H,00001H,00022H);
    CODE(0FFFFH,0FFFFH,0001AH,00015H,00000H,00000H,00175H,00003H);
    CODE(00008H,00005H,00001H,00023H,0FFFFH,0FFFFH,0001AH,00015H);
    CODE(00000H,00000H,00178H,0000AH,00008H,00005H,00001H,00024H);
    CODE(0FFFFH,0FFFFH,0001AH,00015H,00000H,00000H,0017BH,00011H);
    CODE(00008H,00005H,00001H,00025H,0FFFFH,0FFFFH,0001AH,00015H);
    CODE(00000H,00000H,0017EH,00018H,00008H,00005H,00001H,00026H);
    CODE(0FFFFH,0FFFFH,0001AH,00015H,00000H,00000H,00181H,0001FH);
    CODE(00008H,00005H,00001H,00027H,0FFFFH,0FFFFH,0001AH,00015H);
    CODE(00000H,00000H,00184H,00026H,00008H,00005H,00001H,00028H);
    CODE(0FFFFH,0FFFFH,00014H,00080H,00000H,000FFH,01100H,0001BH);
    CODE(0000BH,00011H,00004H,00029H,0FFFFH,0FFFFH,0001CH,00000H);
    CODE(00000H,00000H,00187H,0001DH,0000CH,0000AH,00001H,0002AH);
    CODE(0FFFFH,0FFFFH,0001DH,00008H,00000H,00000H,001FAH,0001DH);
    CODE(0000DH,0000CH,00001H,0002BH,0FFFFH,0FFFFH,0001AH,00007H);
    CODE(00000H,00000H,001B7H,0001FH,00011H,00008H,00001H,00000H);
    CODE(0FFFFH,0FFFFH,0001AH,00025H,00000H,00000H,001BAH,0001FH);
    CODE(00014H,00008H,00001H,00000H,00216H);
END RESOURCEDATA0;

(*........................................................*)

(*$P+*)
PROCEDURE InitResourceTree;
BEGIN
     (* relocate tree indicies *)
     x := ADDRESS(RESOURCEDATA0) + ixTrees;
     TreeAddr := x;
     TreeAddr^[0] := TreeAddr^[0] + ADDRESS(RESOURCEDATA0);
     ob := TreeAddr^[0];
     INC(x,4);
     (* relocate ted infos *)
     x := ADDRESS(RESOURCEDATA0) + ixTedInfos;
     TedInfoAddr := x;
     FOR i := 0 TO nrTedInfos-1 DO
         WITH TedInfoAddr^[i] DO
             ptext := ptext + ADDRESS(RESOURCEDATA0);
             ptmplt := ptmplt + ADDRESS(RESOURCEDATA0);
             pvalid := pvalid + ADDRESS(RESOURCEDATA0);
         END;
     END;
     (* relocate object specs *)
     x := ADDRESS(RESOURCEDATA0) + ixObjects;
     ObjectAddr := x;
     FOR i := 0 TO nrObjects-1 DO
         WITH ObjectAddr^[i] DO
             IF (type <> GBOX)  AND (type <> GPROGDEF) AND
                   (type <> GIBOX) AND (type <> GBOXCHAR) THEN
                 (* relocate against resource base *)
                 spec := spec + ADDRESS(RESOURCEDATA0);
             END;
             (* monochrome scaling only; insert code here
                for detecting colour & scale likewise *)
             x := x*8; y := y*16;
             width := width*8; height := height*16;
         END;
     END;
END InitResourceTree;

(*........................................................*)

END Resource;

(*****************************************************)

PROCEDURE Length(VAR s:ARRAY OF CHAR):CARDINAL;
BEGIN
     RETURN Scan(HIGH(s)+1,CHR(0),TRUE,ADR(s));
END Length;

(*............................................*)

PROCEDURE StrCompare(VAR S1,S2:ARRAY OF CHAR):INTEGER;
 
VAR i,Chrs,Lnth1,Lnth2:INTEGER;
    Ch1,Ch2:CHAR;

BEGIN
     Lnth1:=Length(S1); Lnth2:=Length(S2);
     IF Lnth1<Lnth2 THEN Chrs:=Lnth1 ELSE Chrs:=Lnth2 END;
     FOR i:=0 TO Chrs-1 DO
         Ch1:=S1[i];  Ch2:=S2[i];
         IF Ch1<>Ch2 THEN
             RETURN INTEGER(ORD(Ch1))-INTEGER(ORD(Ch2));
         END;
     END;
     RETURN Lnth1-Lnth2;
END StrCompare;
 
(*.................................................*)
 
PROCEDURE DeselectObject(obindex:INTEGER);
BEGIN
     WITH ob^[obindex] DO
         state := INTEGER(BITSET(state)-{Selected});
     END;
END DeselectObject;

(*............................................*)

PROCEDURE SetTextDefault(obindex:INTEGER; VAR t:ARRAY OF CHAR);

VAR tedaddr:TedPtr;
    
BEGIN
     tedaddr := ob^[obindex].spec;
     tedaddr^.ptext := ADR(t);
END SetTextDefault;

(*............................................*)

PROCEDURE FileSelector(VAR path,file,DefExtents:ARRAY OF CHAR):BOOLEAN;

TYPE StringPtr = POINTER TO ARRAY[0..80] OF CHAR;

VAR result,state,SBoxHeight,CurrExtent,HighLit:INTEGER;
    NumMatches,CurrTop:CARDINAL;
    Defaults:ARRAY[0..9] OF ADDRESS;
    DefExt:ARRAY[0..5] OF ADDRESS;
    FPtr:ARRAY[0..143] OF StringPtr;
    Dir:DirectoryList;
    Extent:ARRAY[0..80] OF CHAR;
    ExtBuff:ARRAY[0..39] OF CHAR;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE FindLastDelimiter(Delim:CHAR; VAR path:ARRAY OF CHAR):INTEGER;

VAR i,place:INTEGER;

BEGIN
     i:=0; place:=-1;
     WHILE path[i]<>0C DO
         IF path[i] = Delim THEN place:=i END;
         INC(i);
     END;
     RETURN place;
END FindLastDelimiter;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE PadFileName(VAR Name:ARRAY OF CHAR; VAR Lnth:CARDINAL);

VAR DotPos:INTEGER;

BEGIN
     DotPos := FindLastDelimiter('.',Name);
     IF (DotPos>=0) AND (DotPos<8) THEN
         MoveRight(ADR(Name[DotPos]),ADR(Name[8]),Lnth-CARDINAL(DotPos));
         WHILE DotPos<8 DO
             Name[DotPos] := ' '; INC(DotPos);
         END;
         Lnth := Length(Name)+1;
     END;
     MoveRight(ADR(Name),ADR(Name[2]),Lnth);
     Name[1] := ' ';
END PadFileName;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE ReadDirectory(VAR Pattern:ARRAY OF CHAR;
                        VAR NumMatches:CARDINAL;
                        VAR DirList:DirectoryList;
                        NormalFilesOnly:BOOLEAN);

VAR result:INTEGER;
    Lnth:CARDINAL;
    Fill:ARRAY BOOLEAN OF CHAR;
    Dir:POINTER TO DirEntry;

BEGIN
     Fill[FALSE] := CHR(7);
     Fill[TRUE] := ' ';
     GetDTA(Dir);
     IF NormalFilesOnly THEN
         SFirst(Pattern,0,result)
       ELSE
         SFirst(Pattern,16,result)
     END;
     WHILE (result=0) AND (NumMatches<144) DO
         IF (NormalFilesOnly) OR ((ODD(ORD(Dir^.FileAttr) DIV 16)) AND
                                           (Dir^.Filename[0]<>'.')) THEN
             (* Filename pass, or is a valid subdirectory *)
              FPtr[NumMatches] := ADR(DirList[NumMatches]);
              WITH DirList[NumMatches] DO
                  Lnth := Length(Dir^.Filename)+1; (* includes NUL *)
                  MoveLeft(ADR(Dir^.Filename),ADR(Name),Lnth);
                  PadFileName(Name,Lnth);
                  Name[0] := Fill[NormalFilesOnly];
              END;
              INC(NumMatches);
         END;
         SNext(result);
     END;
END ReadDirectory;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE SortDirectory(Max:CARDINAL);
 
VAR i:CARDINAL;
    Exchanged:BOOLEAN;
    Temp:ADDRESS;
 
BEGIN
     IF Max<2 THEN RETURN END;
     REPEAT
           DEC(Max);
           Exchanged:=FALSE; i:=0;
           WHILE i<Max DO
               IF StrCompare(FPtr[i]^,FPtr[i+1]^)>0 THEN
                   Temp := FPtr[i];
                   FPtr[i] := FPtr[i+1];
                   FPtr[i+1] := Temp;
                   Exchanged := TRUE;
               END;
               INC(i);
           END;
     UNTIL NOT Exchanged;
END SortDirectory;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE SetSliderPos(NewPos:INTEGER; Drawit:BOOLEAN);

VAR yoff,slh:INTEGER;
    H,NP:REAL;

BEGIN
     NP := FLOAT(CARDINAL(NewPos));
     slh := ob^[SLIDEBOX].height;
     WITH ob^[MVSLIDE] DO
         H := FLOAT(CARDINAL(height));
         yoff := INTEGER(TRUNC(H*NP/1000.0))-(slh DIV 2);
         IF yoff+slh>height THEN
             yoff := height-slh
           ELSIF yoff<0 THEN
             yoff:=0
         END;
     END;
     ob^[SLIDEBOX].y := yoff;
     IF Drawit THEN ObjectDraw(ob,MVSLIDE,2,x,y,w,h) END;
END SetSliderPos;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE CalcSliderPos;

VAR NewPos:INTEGER;

BEGIN
     IF NumMatches<=10 THEN
         NewPos := 0
       ELSIF CurrTop+10>=NumMatches THEN
         NewPos := 1000
       ELSE
         NewPos := TRUNC(FLOAT(CurrTop+5)*1000.0/FLOAT(NumMatches))
     END;
     SetSliderPos(NewPos,FALSE);
END CalcSliderPos;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE CalcSliderSize(Drawit:BOOLEAN);

VAR NewSize:INTEGER;
    H:REAL;

BEGIN
     IF NumMatches<=10 THEN
         ob^[SLIDEBOX].height := ob^[MVSLIDE].height
       ELSE
         WITH ob^[MVSLIDE] DO
             H := FLOAT(CARDINAL(height));
             NewSize := TRUNC(10.0*H/FLOAT(NumMatches));
             IF NewSize<SBoxHeight THEN NewSize:=SBoxHeight END;
         END;
         ob^[SLIDEBOX].height := NewSize;
     END;
     SetSliderPos(0,Drawit);
END CalcSliderSize;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE UpdateDirMenu(DrawIt:BOOLEAN);

VAR i:CARDINAL;

BEGIN
     FOR i:=0 TO 9 DO
         WITH ob^[FILE1+i] DO
             IF i+CurrTop<NumMatches THEN
                 spec := FPtr[i+CurrTop]
               ELSE
                 spec := Defaults[i];
             END;
         END;
     END;
     CalcSliderPos;
     IF DrawIt THEN
         ObjectDraw(ob,DIRECTRY,1,x,y,w,h);
         ObjectDraw(ob,MENUBOX,10,x,y,w,h);
     END;
END UpdateDirMenu;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE DragToNewPos;

VAR SliderNewPos:INTEGER;

BEGIN
     SliderNewPos := GrafSlideBox(ob,MVSLIDE,SLIDEBOX,1);
     SetSliderPos(SliderNewPos,TRUE);
     CurrTop := TRUNC(FLOAT(NumMatches)
                   *FLOAT(CARDINAL(SliderNewPos))/1000.0);
     IF CurrTop>=5 THEN DEC(CurrTop,5) ELSE CurrTop:=0 END;
     UpdateDirMenu(TRUE);
END DragToNewPos;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE MakeSearchPath(ExtNo:INTEGER; DrawIt:BOOLEAN);

VAR PathLnth:CARDINAL;
    StrngPtr:POINTER TO ARRAY[0..80] OF CHAR;

BEGIN
     CurrExtent:=ExtNo;
     NumMatches:=0; CurrTop:=0; Extent:='*.*';
     PathLnth := FindLastDelimiter('\',path)+1;
     IF PathLnth=0 THEN
         PathLnth := FindLastDelimiter(':',path)+1;
         path[PathLnth] := '\'; INC(PathLnth);
     END;
     MoveLeft(ADR(Extent),ADR(path[PathLnth]),4);
     ReadDirectory(path,NumMatches,Dir,FALSE);
     WITH ob^[ExtNo] DO
         StrngPtr := spec;
         MoveLeft(spec,ADR(Extent[1]),Length(StrngPtr^)+1);
     END;
     SetTextDefault(MTOPTEXT,Extent);
     MoveLeft(ADR(Extent),ADR(path[PathLnth]),Length(Extent)+1);
     ReadDirectory(path,NumMatches,Dir,TRUE);
     SortDirectory(NumMatches);
     UpdateDirMenu(DrawIt);
     CalcSliderSize(DrawIt);
END MakeSearchPath;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE RereadDirectory;

VAR PathLnth:CARDINAL;
    StrngPtr:POINTER TO ARRAY[0..80] OF CHAR;
    FullDir:ARRAY[0..3] OF CHAR;

BEGIN
     NumMatches:=0; CurrTop:=0; FullDir:='*.*';
     PathLnth := FindLastDelimiter('\',path)+1;
     IF PathLnth=0 THEN
         PathLnth := FindLastDelimiter(':',path)+1;
     END;
     StrngPtr := ADR(path[PathLnth]);
     MoveLeft(StrngPtr,ADR(Extent),Length(StrngPtr^)+1);
     MoveLeft(ADR(FullDir),ADR(path[PathLnth]),4);
     ReadDirectory(path,NumMatches,Dir,FALSE);
     SetTextDefault(MTOPTEXT,Extent);
     MoveLeft(ADR(Extent),ADR(path[PathLnth]),Length(Extent)+1);
     ReadDirectory(path,NumMatches,Dir,TRUE);
     SortDirectory(NumMatches);
     UpdateDirMenu(TRUE);
END RereadDirectory;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE ChangeDrive(DIndex:INTEGER);

VAR StrngPtr:POINTER TO ARRAY[0..80] OF CHAR;

BEGIN
     WITH ob^[DIndex] DO
         StrngPtr := spec;
         MoveLeft(spec,ADR(path),Length(StrngPtr^)+1);
     END;
     MakeSearchPath(CurrExtent,TRUE);
END ChangeDrive;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE ClearObject(obindex:INTEGER);
BEGIN
     ObjectChange(ob,obindex,0,x,y,w,h,
                  INTEGER(BITSET(ob^[obindex].state)-{Selected}),1);
END ClearObject;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE CancelHighLight;
BEGIN
     IF HighLit<>0 THEN
         ClearObject(HighLit);
         HighLit := 0;
         file[0] := 0C;
         ObjectDraw(ob,FILENAME,1,x,y,w,h);
     END;
END CancelHighLight;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE GetFilename(FIndex:INTEGER):BOOLEAN;

VAR GotFile:BOOLEAN;
    Lnth,DotPos:INTEGER;
    StrngPtr:POINTER TO ARRAY[0..80] OF CHAR;

BEGIN
     file[0] := 0C;
     HighLit := 0;
     GotFile := FALSE;
     WITH ob^[FIndex] DO
         StrngPtr := spec;
         IF StrngPtr^[0]=CHR(7) THEN
             (* a subdirectory *)
             DeselectObject(FIndex);
             Lnth := FindLastDelimiter('\',path)+1;
             MoveLeft(spec+2,ADR(path[Lnth]),Length(StrngPtr^)-1);
             Lnth := INTEGER(Length(path));
             path[Lnth]:='\'; path[Lnth+1]:=0C;
             MakeSearchPath(CurrExtent,TRUE)
           ELSIF CurrTop+CARDINAL(FIndex-FILE1)<NumMatches THEN
             HighLit := FIndex;
             Lnth := INTEGER(Length(StrngPtr^)+1);
             MoveLeft(spec+2,ADR(file),CARDINAL(Lnth-2));
             DEC(Lnth,2);
             DotPos := FindLastDelimiter('.',file);
             IF DotPos>0 THEN
                 MoveLeft(ADR(file[DotPos+1]),ADR(file[DotPos]),
                          CARDINAL((Lnth-DotPos)-1));
             END;
             GotFile := TRUE
           ELSE
             ClearObject(FIndex);
         END;
     END;
     ObjectDraw(ob,FILENAME,1,x,y,w,h);
     RETURN GotFile;
END GetFilename;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE CloseFolder;

VAR SlashPtr:INTEGER;

BEGIN
     SlashPtr := FindLastDelimiter('\',path);
     IF SlashPtr>2 THEN
         path[SlashPtr]:=0C;
         MakeSearchPath(CurrExtent,TRUE);
     END;
END CloseFolder;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE PageDirectory;

VAR mx,my,ox,oy,DontCare1,DontCare2:INTEGER;

BEGIN
     GrafMouseKeyboardState(mx,my,DontCare1,DontCare2);
     ObjectOffset(ob,SLIDEBOX,ox,oy);
     IF my<oy THEN (* if page up *)
         IF CurrTop=0 THEN RETURN END;
         IF CurrTop>=10 THEN DEC(CurrTop,10) ELSE CurrTop:=0 END
       ELSIF CurrTop+10>=NumMatches THEN
         RETURN
       ELSE
         INC(CurrTop,10)
     END;
     UpdateDirMenu(TRUE);
END PageDirectory;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE TakeAction(VAR result:INTEGER);

VAR DoubleClick,GotFile:BOOLEAN;

BEGIN
     DoubleClick := result<0;
     GotFile := FALSE;
     IF DoubleClick THEN
         result := INTEGER(BITSET(result)-{15});
     END;
     IF (result<FILE1) OR (result>FILE10) THEN CancelHighLight END;
     CASE result OF

        DRIVEA..DRIVEH:ChangeDrive(result);
                       ClearObject(result);
       |       MENUBOX,
               MTOPBAR,
              MTOPTEXT:RereadDirectory;
       |       MCLOSER:CloseFolder;
       |       MVSLIDE:PageDirectory;
       |      SLIDEBOX:DragToNewPos;
       |      MUPARROW:IF CurrTop>0 THEN
                           DEC(CurrTop);
                           UpdateDirMenu(TRUE);
                       END;
       |      MDNARROW:IF CurrTop+10<NumMatches THEN
                           INC(CurrTop);
                           UpdateDirMenu(TRUE);
                       END;
       |    EXT1..EXT6:MakeSearchPath(result,TRUE);
                       ClearObject(result);
       | FILE1..FILE10:GotFile := GetFilename(result);
       |      SELECTOK:ClearObject(result);
                       IF file[0]=0C THEN RereadDirectory END;
       |      SELECTCA:ClearObject(result);

      ELSE
     END;
     IF (DoubleClick) AND (GotFile) THEN result:=SELECTOK END;
END TakeAction;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE SetupDefaultExts;

VAR i,Lnth,extno:CARDINAL;
    c:CHAR;

BEGIN
     Lnth := Length(DefExtents);
     IF Lnth>40 THEN Lnth:=40 END;
     MoveLeft(ADR(DefExtents),ADR(ExtBuff),Lnth);
     i:=1; extno:=0;
     REPEAT
           ob^[EXT1+extno].spec := ADR(ExtBuff[i]);
           c := ExtBuff[i];
           WHILE (c<>'|') AND (c<>']') DO
               INC(i); c:=ExtBuff[i];
           END;
           ExtBuff[i]:=0C; INC(i); INC(extno);
     UNTIL (extno=6) OR (c=']');
END SetupDefaultExts;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE InitFileDialog;

VAR i:CARDINAL;
    Drives:DriveSet;

BEGIN
     FOR i:=0 TO 9 DO
         Defaults[i] := ob^[FILE1+i].spec;
         DeselectObject(FILE1+i);
     END;
     FOR i:=0 TO 5 DO
         DefExt[i] := ob^[EXT1+i].spec
     END;
     SBoxHeight := ob^[SLIDEBOX].height;
     SetupDefaultExts;
     MakeSearchPath(EXT1,FALSE);
     SetTextDefault(DIRECTRY,path);
     SetTextDefault(FILENAME,file);
     HighLit := 0;
     Drives := DriveMap();
     FOR i:=0 TO 7 DO
         IF NOT (i IN Drives) THEN
             WITH ob^[DRIVEA+i] DO
                 state := INTEGER(BITSET(state)+{Disabled});
             END;
         END;
     END;
END InitFileDialog;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE RestoreResource;

VAR i:CARDINAL;

BEGIN
     WITH ob^[SLIDEBOX] DO
         y := ob^[MVSLIDE].y;
         height := SBoxHeight;
     END;
     FOR i:=0 TO 9 DO
         ob^[FILE1+i].spec := Defaults[i];
     END;
     FOR i:=0 TO 5 DO
         ob^[EXT1+i].spec := DefExt[i];
     END;
END RestoreResource;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE FixFilename;

VAR Lnth,ptr:CARDINAL;

BEGIN
     Lnth := Length(file);
     IF Lnth>8 THEN
         MoveRight(ADR(file[8]),ADR(file[9]),Lnth-7);
         file[8]:='.'; INC(Lnth);
         IF file[7]=' ' THEN
             ptr:=6;
             WHILE file[ptr]=' ' DO DEC(ptr) END;
             MoveLeft(ADR(file[8]),ADR(file[ptr+1]),Lnth-7);
         END;
     END;
END FixFilename;

(*. . . . . . . . . . . . . . . . . . . . . .*)

BEGIN
     InitFileDialog;
     FormCenter(ob,x,y,w,h);
     FormDialogue(FormStart,0,0,0,0,x,y,w,h);
     FormDialogue(FormGrow,0,0,0,0,x,y,w,h);
     ObjectDraw(ob,0,10,x,y,w,h);
     REPEAT
           result := FormDo(ob,FILENAME);
           TakeAction(result);
     UNTIL ((result=SELECTOK) AND (file[0]<>0C)) OR (result=SELECTCA);
     FormDialogue(FormShrink,0,0,0,0,x,y,w,h);
     FormDialogue(FormFinish,0,0,0,0,x,y,w,h);
     RestoreResource;
     IF result=SELECTOK THEN FixFilename END;
     RETURN result=SELECTOK;
END FileSelector;

(*............................................*)

BEGIN
     InitResourceTree;
END FileSelectorDialog.
