/************************************************************************/
/*      DEFINE.H  Typical miscellaneous C definitions.                  */
/*              Copyright 1985 Atari Corp.                              */
/* changed by B.Nebel (NIL & NULL) 12-5-86                              */
/************************************************************************/

#define NIL 0L                  /* Nil Pointer */
#define NULL 0L                 /* synonym */

#define NO 0                    /* "FALSE" */
#define YES 1                   /* "TRUE" */

#define TRUE 1
#define FALSE 0

#define EOS '\0'                /* End of String marker */
#define EOF (-1)                /* End of File marker */
#define NEWLINE '\n'            /* Carriage Return */

#define FAILURE (-1)            /* Function failure return val */
#define SUCCESS (0)             /* Function success return val */
#define FOREVER for(;;)         /* Infinite loop declaration   */
